package com.hellokoding.jpa;

import com.hellokoding.jpa.model.Book;
import com.hellokoding.jpa.model.Publisher;
import com.hellokoding.jpa.repository.BookRepository;
import com.hellokoding.jpa.repository.PublisherRepository;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;

import javax.transaction.Transactional;
import java.util.Arrays;
import java.util.HashSet;
import java.util.List;

@SpringBootApplication
public class HelloJpaApplication implements CommandLineRunner {
    private static final Logger logger = LoggerFactory.getLogger(HelloJpaApplication.class);

    @Autowired
    private BookRepository bookRepository;

    @Autowired
    private PublisherRepository publisherRepository;

    public static void main(String[] args) {
        SpringApplication.run(HelloJpaApplication.class, args);
    }

    @Override
    @Transactional
    public void run(String... strings) throws Exception {

        // save a couple of publishers
        final Publisher publisherA = new Publisher("Publisher A");
        final Publisher publisherB = new Publisher("Publisher B");
        final Publisher publisherC = new Publisher("Publisher C");

        List<Publisher> publisherList = Arrays.asList(publisherA, publisherB, publisherC);
        publisherRepository.save(publisherList);

        // save a couple of publishers
        final Book bookA = new Book("Book A");
        final Book bookB = new Book("Book B");
        final Book bookC = new Book("Book C");

        List<Book> bookList = Arrays.asList(bookA, bookB, bookC);
        bookRepository.save(bookList);

        // Add a book to a publisher
        bookB.addPublisher(publisherA);
        publisherA.addBook(bookB);
        bookRepository.save(bookB);

        bookC.addPublisher(publisherB);
        publisherB.addBook(bookC);
        bookRepository.save(bookC);


        //Rmove a book
       // bookRepository.delete(bookB);
        //publisherRepository.delete(publisherA);

//        // fetch all books
//        logger.info("After Add");
//        for (Book book : publisherRepository.findByName(publisherA.getName()).getBooks()) {
//            logger.info(book.toString());
//        }


        // Remove a book from a publisher
//        bookB.removePublisher(publisherA);
//        publisherA.removeBook(bookB);
//        bookRepository.save(bookB);
//
//        // fetch all books
//        logger.info("After Remove");
//        for (Book book : publisherA.getBooks()) {
//            logger.info(book.toString());
//        }

    }
}
